PopUpDialog = class(Turbine.UI.Lotro.Window);
function PopUpDialog:Constructor(Title,Message,Icon,Button1,Button2,Button3)
	Turbine.UI.Lotro.Window.Constructor( self );
	local charWidth=8.3 -- rough estimate, but it'll have to do
	self:SetText(Title);
	self:SetVisible(true);
	local titleWidth=string.len(Title)*charWidth;
	local messageWidth=string.len(Message)*charWidth;
	if messageWidth<150 then messageWidth=150 end;
	local messageHeight=20;
	if messageWidth>400 then
		messageHeight=(math.floor(messageWidth/400)+1)*15+5;
		messageWidth=400;
	end
	-- need to add 15 to the message height for each CR character
	local newLine;
	for newLine in string.gmatch(Message, "\n") do
		messageHeight=messageHeight+15;
	end
	messageHeight=messageHeight+15;
	
	self.Loading=true;
	self.Message=Turbine.UI.Label();
	self.Message:SetParent(self);
	self.Message:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
--self.Message:SetBackColor(Turbine.UI.Color(0,.8,1));
	self.Message:SetForeColor(fontColor);
	self.Message:SetSize(messageWidth,messageHeight);
	if Icon==nil then
		if messageWidth+20<titleWidth+140 then
			self:SetSize(titleWidth+140,messageHeight+75);
		else
			self:SetSize(messageWidth+20,messageHeight+75);
		end
		self.Message:SetPosition(10,40);
	else
		self.Icon=Turbine.UI.Control();
		self.Icon:SetParent(self);
		self.Icon:SetSize(32,32);
		self.Icon:SetPosition(10,40);
		self.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
		if Icon==1 then
			self.Icon:SetBackground("GaranStuff/MoorMap/Resources/Exclamation.tga");
		elseif Icon==2 then
			self.Icon:SetBackground("GaranStuff/MoorMap/Resources/Question.tga");
		elseif Icon==3 then
			self.Icon:SetBackground("GaranStuff/MoorMap/Resources/Critical.tga");
		else
			-- default to Information
			self.Icon:SetBackground("GaranStuff/MoorMap/Resources/Information.tga");
		end
		if messageHeight<35 then messageHeight=35 end; -- force minimum height
		if messageWidth+60<titleWidth+140 then
			self:SetSize(titleWidth+140,messageHeight+75);
		else
			self:SetSize(messageWidth+60,messageHeight+75);
		end
		self.Message:SetPosition(50,40);
	end
	self:SetPosition((Turbine.UI.Display:GetWidth() - self:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - self:GetHeight()) / 2);
	self.Message:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.Message:SetText(Message)

-- buttons
	local buttonWidth=50;
	self.Buttons={}
	if Button1~=nil then
		self.Buttons[#self.Buttons+1]=Turbine.UI.Lotro.Button();
		self.Buttons[#self.Buttons]:SetParent(self);
		self.Buttons[#self.Buttons]:SetSize(100,20);
		self.Buttons[#self.Buttons].Value=1;
		self.Buttons[#self.Buttons]:SetTop(self:GetHeight()-30);
		self.Buttons[#self.Buttons]:SetText(Button1);
		self.Buttons[#self.Buttons].Click=function()
			-- return 1
			self:SetVisible(false);
		end
		if string.len(Button1)*charWidth>buttonWidth then buttonWidth=string.len(Button1)*charWidth end
	end
	if Button2~=nil then
		self.Buttons[#self.Buttons+1]=Turbine.UI.Lotro.Button();
		self.Buttons[#self.Buttons]:SetParent(self);
		self.Buttons[#self.Buttons]:SetSize(100,20);
		self.Buttons[#self.Buttons].Value=2;
		self.Buttons[#self.Buttons]:SetTop(self:GetHeight()-30);
		self.Buttons[#self.Buttons]:SetText(Button2);
		self.Buttons[#self.Buttons].Click=function()
			-- return 2
			self:SetVisible(false);
		end
		if string.len(Button2)*charWidth>buttonWidth then buttonWidth=string.len(Button2)*charWidth end
	end
	if Button3~=nil then
		self.Buttons[#self.Buttons+1]=Turbine.UI.Lotro.Button();
		self.Buttons[#self.Buttons]:SetParent(self);
		self.Buttons[#self.Buttons]:SetSize(100,20);
		self.Buttons[#self.Buttons].Value=3;
		self.Buttons[#self.Buttons]:SetTop(self:GetHeight()-30);
		self.Buttons[#self.Buttons]:SetText(Button3);
		self.Buttons[#self.Buttons].Click=function()
			-- return 3
			self:SetVisible(false);
		end
		if string.len(Button3)*charWidth>buttonWidth then buttonWidth=string.len(Button3)*charWidth end
	end
	for index=1, #self.Buttons do
		self.Buttons[index]:SetWidth(buttonWidth);
	end
	-- make sure dialog is wide enough for all of its buttons
	if #self.Buttons*buttonWidth+60>self:GetWidth() then
		self:SetWidth(#self.Buttons*(buttonWidth+10)+40)
		if Icon==nil then
			self.Message:SetWidth(self:GetWidth()-20);
		else
			self.Message:SetWidth(self:GetWidth()-60);
		end
	end

	if #self.Buttons==0 then
		-- throw an error and exit. we can't display a dialog with no buttons
	elseif #self.Buttons==1 then
		self.Buttons[1]:SetLeft((self:GetWidth()-self.Buttons[1]:GetWidth())/2);
	elseif #self.Buttons==2 then
		self.Buttons[1]:SetLeft((self:GetWidth()-self.Buttons[1]:GetWidth()*2)/3);
		self.Buttons[2]:SetLeft(self:GetWidth()-self.Buttons[1]:GetWidth()-self.Buttons[1]:GetLeft());
	else
		self.Buttons[1]:SetLeft(25);
		self.Buttons[2]:SetLeft((self:GetWidth()-self.Buttons[1]:GetWidth())/2);
		self.Buttons[3]:SetLeft(self:GetWidth()-self.Buttons[3]:GetWidth()-25);
	end
	self.Update=function()
		if self.Loading then
			self:SetWantsUpdates(false);
			self.Loading=false;
			self:SetZOrder(self:GetZOrder()+1);
		end
	end
	self:SetWantsUpdates(true);
end
